//
//  SoftwareUpdateParameters.swift
//  
//
//  Created by Jakob on 29.11.20.
//

import Foundation

/// Parameters for the SoftwareUpdater application.
class SoftwareUpdateParameters: Encodable
{
	static let fileName = "parameters.json"
	
	/// e.g. "Jakob.Pix"
	let bundleId: String

	/// e.g. "Pix"
	let shortAppName: String
	
	/// name of the appl. folder under www.jakob-spies.de, e.g. "pix" or "GanttMeister"
	let urlPath: String
	
	/// Is the inflated ZIP file a folder containing the .app, or is it the .app itself?
	let isInFolder: Bool
	
	init(bundleId: String, shortAppName: String, urlPath: String, isInFolder: Bool) {
		self.bundleId = bundleId
		self.isInFolder = isInFolder
		self.shortAppName = shortAppName
		self.urlPath = urlPath
	}
}
