//
//  AppDelegate.swift
//  Filmbeschaffer
//
//  Created by Jakob on 20.5.18.
//  Copyright © 2018 Jakob. All rights reserved.
//

import Cocoa
import AppUtilLib

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate, NSUserInterfaceValidations, DownloadEventListener
{
	//MARK: Public

	@IBAction
	func newDownload(_ sender: AnyObject){
		theDownloadWindowController.show()
	}

	@IBAction
	func newStreamDownload(_ sender: AnyObject){
		theDownloadWindowController.show(true)
	}

	@IBAction
	func openPreferences(_ sender: AnyObject)
	{
		PreferencesController.openPreferences()
	}

	func applicationDidFinishLaunching(_ notification: Notification)
	{
		theDownloadWindowController.listener = self
		theDownloadsWindow.show()

		if Preferences.instance.isCheckVersion {
			do {
				try Updater(appName: Preferences.APP_NAME, wwwPath: Preferences.WWW_PATH, isInFolder: false).updateIfNecessary()
			} catch {
				Exception.handle(error)
				// but continue
			}
		}
	}

	func process(_ download: Download) {
		theDownloadsWindow.add(download: download)
	}

	func validateUserInterfaceItem(_ item: NSValidatedUserInterfaceItem) -> Bool
	{
		let action = item.action

		return action == #selector(newDownload) || action == #selector(newStreamDownload) || action == #selector(openPreferences)
	}

	//MARK: Private

	private var theDownloadWindowController = DownloadWindowController.create()
	private var theDownloadsWindow = DownloadsWindowController.create()
}
