//
//  ArteUrlFinder.swift
//  Filmbeschaffer
//
//  Created by Jakob on 20.5.18.
//  Copyright © 2018 Jakob. All rights reserved.
//

import Foundation
import os.log

class ArteUrlFinder: Downloader, UrlFinder
{
	private static let VSR = "VSR"
	private static let MAIN_QUALITY = "mainQuality"
	private static let LABEL = "label"

	func findVideoUrl(_ baseUrl: URL) throws -> URL
	{
		let pathComp = baseUrl.pathComponents

		if pathComp.count < 4 {
			throw DownloadError("URL has too few path components")
		}

		let name: String = pathComp[3]
		let url = try HtmlUtil.toUrl("https://api.arte.tv/api/player/v2/config/de/" + name)
		let page = try getUtf8TextPage(url, headers: ["X-Validated-Age" : "18"]) // 😎
		var json = try HtmlUtil.deserialize(page)

		json = try HtmlUtil.attribute("data", in: json)
		json = try HtmlUtil.attribute("attributes", in: json)
		json = try HtmlUtil.firstObjOfArrayAttribute("streams", in: json)
		
		return try HtmlUtil.urlAttribute("url", in: json)
	}

	func findVideoUrlVersion1(_ baseUrl: URL) throws -> URL
	{
		let pathComp = baseUrl.pathComponents

		if pathComp.count < 4 {
			throw DownloadError("URL has too few path components")
		}

		let url = try HtmlUtil.toUrl("https://api.arte.tv/api/player/v1/config/de/" + pathComp[3])
		var page = try getUtf8TextPage(url)
		var json = try HtmlUtil.deserialize(page)

		json = try HtmlUtil.attribute("videoJsonPlayer", in: json)

		let desc = "attribute \(ArteUrlFinder.VSR)"

		json = try HtmlUtil.attribute(ArteUrlFinder.VSR, in: json)

		json =
			try HtmlUtil.attribute(
				"HTTPS_SQ_1",
				in: json,
				descNotDict: desc + " is \(json), which",
				descMissing: desc
			)

		page = try HtmlUtil.stringAttribute("url", in: json)
		return try HtmlUtil.toUrl(page)
	}
}
