//
//  PreferencesController.swift
//  Filmbeschaffer
//
//  Created by Jakob on 3.6.18.
//  Copyright © 2018 Jakob. All rights reserved.
//

import Cocoa
import AppUtilLib

class PreferencesController: NSWindowController
{
	//MARK: Public

	static func openPreferences(){
		inst = PreferencesController()
	}

	@IBOutlet var speedCalcTimeSpanField: NSTextField!

	required init?(coder: NSCoder) {
		fatalError("init(coder:) has not been implemented")
	}

	override init(window: NSWindow?) {
		super.init(window: window)
	}

	func windowWillClose(_ notification: Notification){
		// save memory
		PreferencesController.inst = nil
	}

	@IBAction func setSpeedCalcTimeSpan(_ sender: Any) {
		guard let val = speedCalcTimeSpanField?.doubleValue else {
			NSSound.beep()
			return
		}
		Preferences.instance.speedCalculationTimeSpan = val
	}

	@IBAction
	func setCheckUpdates(_ sender: NSButton) {
		let doCheck = sender.state == .on

		Preferences.instance.isCheckVersion = doCheck

		if doCheck {
			VersionCheck1(path: Preferences.WWW_PATH, name: Preferences.APP_NAME, file: Preferences.APP_NAME + ".zip")
				.checkVersion()
		}
	}

	//MARK: Private

	/// Such that the window does not get garbage-collected immediately.
	private static var inst: PreferencesController?


	private convenience init(){
		self.init(windowNibName: "PreferencesWindow")

		guard let win = window else {
			NSSound.beep()
			return
		}

		speedCalcTimeSpanField?.doubleValue = Preferences.instance.speedCalculationTimeSpan
		win.makeKeyAndOrderFront(self)
	}
}
